--////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
-- Name: Operation Black Spire
-- Author: Surrexen    ༼ つ ◕_◕ ༽つ    (づ｡◕‿◕｡)づ 
--////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
--////MISSION LOGIC FUNCTIONS

function SEF_MissionSelector()	
	
	if ( NumberOfCompletedMissions >= TotalScenarios ) then
			
		OperationComplete = true
		trigger.action.outText("Operation Black Spire Has Been Successful", 15)
		--WRITE PROGRESS TABLES TO EMPTY AND SAVE WITH NO ARGUMENTS
		BlackSpireUnitInterment = {}
		SEF_SaveUnitIntermentTableNoArgs()
		BlackSpireStaticInterment = {}
		SEF_SaveStaticIntermentTableNoArgs()			
	else
		Randomiser = math.random(1,TotalScenarios)
		if ( trigger.misc.getUserFlag(Randomiser) > 0 ) then
			--SELECTED MISSION [Randomiser] ALREADY DONE, FLAG VALUE >=1, SELECT ANOTHER ONE
			SEF_MissionSelector()
		elseif ( trigger.misc.getUserFlag(Randomiser) == 0 ) then
			--SELECTED MISSION [Randomiser] IS AVAILABLE TO START, SET TO STARTED AND VALIDATE
			trigger.action.setUserFlag(Randomiser,1)
			SEF_RetrieveMissionInformation(Randomiser)
			--trigger.action.outText("Validating Mission Number "..Randomiser.." For Targeting", 15)
			SEF_ValidateMission()										
		else
			trigger.action.outText("Mission Selection Error", 15)
		end
	end		
end

function SEF_RetrieveMissionInformation ( MissionNumber )
	
	--SET GLOBAL VARIABLES TO THE SELECTED MISSION
	ScenarioNumber = MissionNumber
	AGMissionTarget = OperationBlackSpire_AG[MissionNumber].TargetName
	AGTargetTypeStatic = OperationBlackSpire_AG[MissionNumber].TargetStatic
	AGMissionBriefingText = OperationBlackSpire_AG[MissionNumber].TargetBriefing		
end

function SEF_ValidateMission()
	
	--CHECK TARGET TO SEE IF IT IS ALIVE OR NOT
	if ( AGTargetTypeStatic == false and AGMissionTarget ~= nil ) then
		--TARGET IS NOT STATIC					
		if ( GROUP:FindByName(AGMissionTarget):IsAlive() == true ) then
			--GROUP VALID
			trigger.action.outSound('That Is Our Target.ogg')
			trigger.action.outText(AGMissionBriefingText,15)			
		elseif ( GROUP:FindByName(AGMissionTarget):IsAlive() == false or GROUP:FindByName(AGMissionTarget):IsAlive() == nil ) then
			--GROUP NOT VALID
			trigger.action.setUserFlag(ScenarioNumber,4)
			NumberOfCompletedMissions = NumberOfCompletedMissions + 1
			AGMissionTarget = nil
			AGMissionBriefingText = nil
			SEF_MissionSelector()						
		else			
			trigger.action.outText("Mission Validation Error - Unexpected Result In Group Size", 15)						
		end		
	elseif ( AGTargetTypeStatic == true and AGMissionTarget ~= nil ) then		
		--TARGET IS STATIC		
		if ( StaticObject.getByName(AGMissionTarget) ~= nil and StaticObject.getByName(AGMissionTarget):isExist() == true ) then
			--STATIC IS VALID
			trigger.action.outSound('That Is Our Target.ogg')
			trigger.action.outText(AGMissionBriefingText,15)								
		elseif ( StaticObject.getByName(AGMissionTarget) == nil or StaticObject.getByName(AGMissionTarget):isExist() == false ) then
			--STATIC TARGET NOT VALID, ASSUME TARGET ALREADY DESTROYED			
			trigger.action.setUserFlag(ScenarioNumber,4)
			NumberOfCompletedMissions = NumberOfCompletedMissions + 1	
			AGMissionTarget = nil
			AGMissionBriefingText = nil
			SEF_MissionSelector()
		else
			trigger.action.outText("Mission Validation Error - Unexpected Result In Static Test", 15)	
		end		
	elseif ( OperationComplete == true ) then
		trigger.action.outText("The Operation Is Complete - No Further Targets To Validate For Mission Assignment", 15)
	else		
		trigger.action.outText("Mission Validation Error - Mission Validation Unavailable, No Valid Targets", 15)
	end
end

function SEF_SkipScenario()	
	--CHECK MISSION IS NOT SUDDENLY FLAGGED AS STATE 4 (COMPLETED)
	if ( trigger.misc.getUserFlag(ScenarioNumber) >= 1 and trigger.misc.getUserFlag(ScenarioNumber) <= 3 ) then
		--RESET MISSION TO STATE 0 (NOT STARTED), CLEAR TARGET INFORMATION AND REROLL A NEW MISSION
		trigger.action.setUserFlag(ScenarioNumber,0) 
		AGMissionTarget = nil
		AGMissionBriefingText = nil
		SEF_MissionSelector()
	elseif ( OperationComplete == true ) then
		trigger.action.outText("The Operation Has Been Completed, All Objectives Have Been Met", 15)
	else		
		trigger.action.outText("Unable To Skip As Current Mission Is In A Completion State", 15)
	end
end

function MissionSuccess()
	
	--SET GLOBALS TO NIL
	AGMissionTarget = nil
	AGMissionBriefingText = nil
	
	local RandomMissionSuccessSound = math.random(1,5)
	trigger.action.outSound('AG Kill ' .. RandomMissionSuccessSound .. '.ogg')	
end

function SEF_MissionTargetStatus(TimeLoop, time)

	if (AGTargetTypeStatic == false and AGMissionTarget ~= nil) then
		--TARGET IS NOT STATIC
					
		if (GROUP:FindByName(AGMissionTarget):IsAlive() == true) then
			--GROUP STILL ALIVE
						
			return time + 10			
		elseif (GROUP:FindByName(AGMissionTarget):IsAlive() == false or GROUP:FindByName(AGMissionTarget):IsAlive() == nil) then 
			--GROUP DEAD
			trigger.action.outText("Mission Update - Mission Successful", 15)
			trigger.action.setUserFlag(ScenarioNumber,4)
			NumberOfCompletedMissions = NumberOfCompletedMissions + 1
			MissionSuccess()
			timer.scheduleFunction(SEF_MissionSelector, {}, timer.getTime() + 20)
			
			return time + 30			
		else			
			trigger.action.outText("Mission Target Status - Unexpected Result, Monitor Has Stopped", 15)						
		end		
	elseif (AGTargetTypeStatic == true and AGMissionTarget ~= nil) then
		--TARGET IS STATIC
		if ( StaticObject.getByName(AGMissionTarget) ~= nil and StaticObject.getByName(AGMissionTarget):isExist() == true ) then
			--STATIC ALIVE
			
			return time + 10				
		else				
			--STATIC DESTROYED
			trigger.action.outText("Mission Update - Mission Successful", 15)
			trigger.action.setUserFlag(ScenarioNumber,4)
			NumberOfCompletedMissions = NumberOfCompletedMissions + 1
			MissionSuccess()
			timer.scheduleFunction(SEF_MissionSelector, {}, timer.getTime() + 20)
			
			return time + 30				
		end		
	else		
		return time + 10
	end	
end

--////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
--////MISSION TARGET TABLE

function SEF_InitializeMissionTable()
	
	OperationBlackSpire_AG = {}	
	--//////////
	--HOOVER DAM
	OperationBlackSpire_AG[1] = {				
		TargetName = "Hoover Dam - Comms",
		TargetStatic = true,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Communications Tower located at the Hoover Dam\nHoover Dam Sector - Grid QV08",
	}				
	OperationBlackSpire_AG[2] = {
		TargetName = "Hoover Dam - AAA 1",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy AAA assets located at the Hoover Dam\nHoover Dam Sector - Grid QV08",
	}	
	OperationBlackSpire_AG[3] = {
		TargetName = "Hoover Dam - Iglas 1",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Anti-Air Infantry located at the Hoover Dam\nHoover Dam Sector - Grid QV08",
	}
	--///////////////
	--MAJOR SAM SITES
	OperationBlackSpire_AG[4] = {
		TargetName = "62A - SA-2 Site 3",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the SA-2 site located in Sector 62A\n62A Sector - Grid PA48",
	}
	OperationBlackSpire_AG[5] = {
		TargetName = "Tonopah South - SA-10 Site 1",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the SA-10 site located South of Tonopah Test Range Airfield\nTonopah South Sector - Grid NB12",
	}	
	OperationBlackSpire_AG[6] = {
		TargetName = "Tonopah North - SA-3 Site 2",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the SA-3 site located South-West of Tonopah Test Range Airfield\nTonopah North Sector - Grid NB06",
	}
	OperationBlackSpire_AG[7] = {
		TargetName = "Tonopah South - SA-3 Site 3",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the SA-3 site located South of Tonopah Test Range Airfield\nTonopah South Sector - Grid NB13",
	}
	OperationBlackSpire_AG[8] = {
		TargetName = "Tonopah North - SA-2 Site 4",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the SA-2 site located South-West of Tonopah Test Range Airfield\nTonopah North Sector - Grid NB06",
	}
	OperationBlackSpire_AG[9] = {
		TargetName = "Tonopah South - SA-2 Site 5",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the SA-2 site located South of Tonopah Test Range Airfield\nTonopah South Sector - Grid NB13",
	}
	OperationBlackSpire_AG[10] = {
		TargetName = "Tonopah South - SA-2 Site 6",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the SA-2 site located South of Tonopah Test Range Airfield\nTonopah South Sector - Grid NB12",
	}
	OperationBlackSpire_AG[11] = {
		TargetName = "Tonopah East - SA-2 Site 7",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the SA-2 site located South-East of Tonopah Test Range Airfield\nTonopah East Sector - Grid NB63",
	}
	OperationBlackSpire_AG[12] = {
		TargetName = "Tonopah East - SA-2 Site 8",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the SA-2 site located South-East of Tonopah Test Range Airfield\nTonopah East Sector - Grid NB64",
	}
	OperationBlackSpire_AG[13] = {
		TargetName = "Tonopah North - SA-2 Site 9",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the SA-2 site located South-East of Tonopah Test Range Airfield\nTonopah North Sector - Grid NB37",
	}
	--/////////////
	--SAM Supply
	OperationBlackSpire_AG[14] = {
		TargetName = "62A - Site 3 Supply 1",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Supply Trucks supplying the SA-2 site in Sector 62A\n62A Sector - Grid PA48",
	}
	OperationBlackSpire_AG[15] = {
		TargetName = "Tonopah South - Site 1 Supply 1",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Supply Trucks supplying the SA-10 site located South of Tonopah Test Range Airfield\nTonopah South Sector - Grid NB12",
	}
	OperationBlackSpire_AG[16] = {
		TargetName = "Tonopah North - Site 2 Supply 1",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Supply Trucks supplying the SA-3 site located South-West of Tonopah Test Range Airfield\nTonopah North Sector - Grid NB06",
	}
	OperationBlackSpire_AG[17] = {
		TargetName = "Tonopah South - Site 3 Supply 1",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Supply Trucks supplying the SA-3 site located South of Tonopah Test Range Airfield\nTonopah South Sector - Grid NB13",
	}
	OperationBlackSpire_AG[18] = {
		TargetName = "Tonopah North - Site 4 Supply 1",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Supply Trucks supplying the SA-2 site located South-West of Tonopah Test Range Airfield\nTonopah North Sector - Grid NB06",
	}
	OperationBlackSpire_AG[19] = {
		TargetName = "Tonopah South - Site 5 Supply 1",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Supply Trucks supplying the SA-2 site located South of Tonopah Test Range Airfield\nTonopah South Sector - Grid NB13",
	}
	OperationBlackSpire_AG[20] = {
		TargetName = "Tonopah South - Site 6 Supply 1",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Supply Trucks supplying the SA-2 site located South of Tonopah Test Range Airfield\nTonopah South Sector - Grid NB12",
	}
	OperationBlackSpire_AG[21] = {
		TargetName = "Tonopah East - Site 7 Supply 1",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Supply Trucks supplying the SA-2 site located South-East of Tonopah Test Range Airfield\nTonopah East Sector - Grid NB63",
	}
	OperationBlackSpire_AG[22] = {
		TargetName = "Tonopah East - Site 8 Supply 1",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Supply Trucks supplying the SA-2 site located South-East of Tonopah Test Range Airfield\nTonopah East Sector - Grid NB64",
	}
	OperationBlackSpire_AG[23] = {
		TargetName = "Tonopah North - Site 9 Supply 1",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Supply Trucks supplying the SA-2 site located South-East of Tonopah Test Range Airfield\nTonopah North Sector - Grid NB37",
	}
	--/////////////
	--EWR
	OperationBlackSpire_AG[24] = {
		TargetName = "Caliente Charlie - EWR Cedar Range",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Early Warning Radar located on the Cedar Mountain Range\nCaliente Charlie Sector - Grid QB45",
	}
	OperationBlackSpire_AG[25] = {
		TargetName = "Area 51 - EWR Jumbled Hills",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Early Warning Radar located on the Jumbled Hills\nArea 51 Sector - Grid PB21/22",
	}
	OperationBlackSpire_AG[26] = {
		TargetName = "Caliente Alpha - EWR Pahroc",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Early Warning Radar located on the South Pahroc Mountain Range\nCaliente Alpha Sector - Grid PB75",
	}
	OperationBlackSpire_AG[27] = {
		TargetName = "Pahute - EWR Timber Mountain",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Early Warning Radar located on Timber Mountain\nPahute Sector - Grid NB40",
	}	
	--/////////////////
	--62A
	--62A Bombing Range
	OperationBlackSpire_AG[28] = {
		TargetName = "62A - Trucks 1",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Trucks located South of the SA-2 site in Sector 62A\n62A Sector - Grid PA37",
	}
	OperationBlackSpire_AG[29] = {
		TargetName = "62A - Buses 1",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Buses located South of the SA-2 site in Sector 62A\n62A Sector - Grid PA37",
	}
	OperationBlackSpire_AG[30] = {
		TargetName = "62A - Garage",
		TargetStatic = true,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Garage located South of the SA-2 site in Sector 62A\n62A Sector - Grid PA37",
	}
	OperationBlackSpire_AG[31] = {
		TargetName = "62A - Vaz 1",
		TargetStatic = true,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Cars located South of the SA-2 site in Sector 62A\n62A Sector - Grid PA37",
	}	
	--//////////////
	--AREA 51
	--Groom Lake AFB
	OperationBlackSpire_AG[32] = {
		TargetName = "Area 51 - SAM 1",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Mobile SAM at the Groom Lake Air Force Base\nArea 51 Sector - Grid PB02",
	}
	OperationBlackSpire_AG[33] = {
		TargetName = "Area 51 - Drone Control Tower",
		TargetStatic = true,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Drone Control Tower at the Groom Lake Air Force Base\nArea 51 Sector - Grid PB02",
	}
	OperationBlackSpire_AG[34] = {
		TargetName = "Area 51 - AAA 1",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the AAA Assets at the Groom Lake Air Force Base\nArea 51 Sector - Grid PB02",
	}
	OperationBlackSpire_AG[35] = {
		TargetName = "Area 51 - Drone",
		TargetStatic = true,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the MQ-9 Aerial Drone at the Groom Lake Air Force Base\nArea 51 Sector - Grid PB02",
	}
	OperationBlackSpire_AG[36] = {
		TargetName = "Area 51 - Drone Hangar",
		TargetStatic = true,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Drone Hangar at the Groom Lake Air Force Base\nArea 51 Sector - Grid PB02",
	}
	OperationBlackSpire_AG[37] = {
		TargetName = "Area 51 - Supply 1",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Supply Trucks at the Groom Lake Air Force Base\nArea 51 Sector - Grid PB02",
	}
	OperationBlackSpire_AG[38] = {
		TargetName = "Area 51 - Supply 2",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Fuel Trucks at the Groom Lake Air Force Base\nArea 51 Sector - Grid PB02",
	}
	OperationBlackSpire_AG[39] = {
		TargetName = "Area 51 - AH-64D",
		TargetStatic = true,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the AH-64D Apache at the Groom Lake Air Force Base\nArea 51 Sector - Grid PB02",
	}
	--Area 51 Tank Farm
	OperationBlackSpire_AG[40] = {
		TargetName = "Area 51 - Tank Hangar",
		TargetStatic = true,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Tank Repair Hangar at the Tank Farm located North of the Groom Lake Air Force Base\nArea 51 Sector - Grid NB93",
	}
	OperationBlackSpire_AG[41] = {
		TargetName = "Area 51 - Armor 1",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Merkava Mk.4 Tanks at the Tank Farm located North of the Groom Lake Air Force Base\nArea 51 Sector - Grid NB93",
	}
	OperationBlackSpire_AG[42] = {
		TargetName = "Area 51 - SAM 2",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Mobile SAM at the Tank Farm located North of the Groom Lake Air Force Base\nArea 51 Sector - Grid NB93",
	}
	OperationBlackSpire_AG[43] = {
		TargetName = "Area 51 - Comms",
		TargetStatic = true,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Communications Tower at the Tank Farm located North of the Groom Lake Air Force Base\nArea 51 Sector - Grid NB93",
	}
	OperationBlackSpire_AG[44] = {
		TargetName = "Area 51 - AAA 2",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the AAA Assets at the Tank Farm located North of the Groom Lake Air Force Base\nArea 51 Sector - Grid NB93",
	}
	OperationBlackSpire_AG[45] = {
		TargetName = "Area 51 - Supply 3",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Supply Trucks at the Tank Farm located North of the Groom Lake Air Force Base\nArea 51 Sector - Grid NB93",
	}
	--/////////////////////
	--CALIENTE ALPHA
	--Alien Research Centre
	OperationBlackSpire_AG[46] = {
		TargetName = "Caliente Alpha - Research Hangar",
		TargetStatic = true,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Research Hangar at the Alien Research Centre West of Crystal Springs\nCaliente Alpha Sector - Grid PB55",
	}
	OperationBlackSpire_AG[47] = {
		TargetName = "Caliente Alpha - Suspicious Transport",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Suspicious Transport Vehicle at the Alien Research Centre West of Crystal Springs\nCaliente Alpha Sector - Grid PB55",
	}
	OperationBlackSpire_AG[48] = {
		TargetName = "Caliente Alpha - Suspicious Container",
		TargetStatic = true,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Suspicious Containter at the Alien Research Centre West of Crystal Springs\nCaliente Alpha Sector - Grid PB55",
	}
	OperationBlackSpire_AG[49] = {
		TargetName = "Caliente Alpha - Comms",
		TargetStatic = true,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Communications Tower at the Alien Research Centre West of Crystal Springs\nCaliente Alpha Sector - Grid PB55",
	}
	OperationBlackSpire_AG[50] = {
		TargetName = "Caliente Alpha - Infantry 1",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Anti-Air Infantry at the Alien Research Centre West of Crystal Springs\nCaliente Alpha Sector - Grid PB55",
	}
	OperationBlackSpire_AG[51] = {
		TargetName = "Caliente Alpha - Suspicious House",
		TargetStatic = true,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Suspicious House at the Alien Research Centre West of Crystal Springs\nCaliente Alpha Sector - Grid PB55",
	}
	OperationBlackSpire_AG[52] = {
		TargetName = "Caliente Alpha - SAM 1",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Mobile SAM located East of Crystal Springs\nCaliente Alpha Sector - Grid PB65",
	}
	--Caliente Alpha Terrorist Hideout
	OperationBlackSpire_AG[53] = {
		TargetName = "Caliente Alpha - SAM 2",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Mobile SAM at the Suspected Terrorist Hideout located West of Chokecherry Mountain\nCaliente Alpha Sector - Grid PB95",
	}
	OperationBlackSpire_AG[54] = {
		TargetName = "Caliente Alpha - AAA 1",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the AAA Assets at the Suspected Terrorist Hideout located West of Chokecherry Mountain\nCaliente Alpha Sector - Grid PB95",
	}
	OperationBlackSpire_AG[55] = {
		TargetName = "Caliente Alpha - Hideout",
		TargetStatic = true,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Suspected Terrorist Hideout located West of Chokecherry Mountain\nCaliente Alpha Sector - Grid PB95",
	}
	OperationBlackSpire_AG[56] = {
		TargetName = "Caliente Alpha - Infantry 2",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Anti-Air Infantry at the Suspected Terrorist Hideout located West of Chokecherry Mountain\nCaliente Alpha Sector - Grid PB95",
	}
	OperationBlackSpire_AG[57] = {
		TargetName = "Caliente Alpha - Supply 1",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Supply Trucks at the Suspected Terrorist Hideout located West of Chokecherry Mountain\nCaliente Alpha Sector - Grid PB95",
	}
	--////////////////	
	--CALIENTE CHARLIE	
	OperationBlackSpire_AG[58] = {
		TargetName = "Caliente Charlie - Armor 1",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Armored Vehicles located in Caliente Charlie\nCaliente Charlie Sector - Grid QB57",
	}
	OperationBlackSpire_AG[59] = {
		TargetName = "Caliente Charlie - SAM 1",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Mobile SAM located in Caliente Charlie\nCaliente Charlie Sector - Grid QB57",
	}
	OperationBlackSpire_AG[60] = {
		TargetName = "Caliente Charlie - Supply 1",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Supply Trucks located in Caliente Charlie\nCaliente Charlie Sector - Grid QB57",
	}
	OperationBlackSpire_AG[61] = {
		TargetName = "Caliente Charlie - AAA 1",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the AAA Assets located in Caliente Charlie\nCaliente Charlie Sector - Grid QB57",
	}
	OperationBlackSpire_AG[62] = {
		TargetName = "Caliente Charlie - Comms",
		TargetStatic = true,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Communications Tower located in Caliente Charlie\nCaliente Charlie Sector - Grid QB46",
	}	
	--////////////////////
	--PAHUTE
	--Pahute Bombing Range
	OperationBlackSpire_AG[63] = {
		TargetName = "Pahute - Relay Tower",
		TargetStatic = true,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Radio Relay Tower at the Bombing Range North-West of Pahute Mesa Airstrip\nPahute Sector - Grid NB42",
	}
	OperationBlackSpire_AG[64] = {
		TargetName = "Pahute - Tech Warehouse",
		TargetStatic = true,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Tech Warehouse at the Bombing Range North-West of Pahute Mesa Airstrip\nPahute Sector - Grid NB42",
	}
	OperationBlackSpire_AG[65] = {
		TargetName = "Pahute - SAM 1",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Mobile SAM's at the Bombing Range North-West of Pahute Mesa Airstrip\nPahute Sector - Grid NB41",
	}
	OperationBlackSpire_AG[66] = {
		TargetName = "Pahute - AAA 1",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the AAA Assets at the Bombing Range North-West of Pahute Mesa Airstrip\nPahute Sector - Grid NB42",
	}
	OperationBlackSpire_AG[67] = {
		TargetName = "Pahute - Artillery 1",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Artillery Vehicles at the Bombing Range North-West of Pahute Mesa Airstrip\nPahute Sector - Grid NB41",
	}
	--///////////////////
	--RACHEL
	--Rachel's Pet Spider
	OperationBlackSpire_AG[68] = {
		TargetName = "Rachel - Spider",
		TargetStatic = true,
		TargetBriefing = "Mission Update \nPrimary Objective - Rachel's Pet Spider has escaped and must be destroyed!\nRachel Sector - Grid PB25",
	}
	OperationBlackSpire_AG[69] = {
		TargetName = "Rachel - SAM 1",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Mobile SAM protecting Rachel's Pet Spider\nRachel Sector - Grid PB25",
	}
	OperationBlackSpire_AG[70] = {
		TargetName = "Rachel - AAA 1",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the AAA Assets protecting Rachel's Pet Spider\nRachel Sector - Grid PB25",
	}
	OperationBlackSpire_AG[71] = {
		TargetName = "Rachel - Supply 1",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Supply Trucks feeding Rachel's Pet Spider\nRachel Sector - Grid PB25",
	}
	--Rachel Suspicious Farm
	OperationBlackSpire_AG[72] = {
		TargetName = "Rachel - SAM 2",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Mobile SAM units at the Suspicious Farm North of Rachel\nRachel Sector - Grid PB18",
	}
	OperationBlackSpire_AG[73] = {
		TargetName = "Rachel - AAA 2",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the AAA Assets at the Suspicious Farm North of Rachel\nRachel Sector - Grid PB18",
	}
	OperationBlackSpire_AG[74] = {
		TargetName = "Rachel - Supply 2",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Supply Trucks at the Suspicious Farm North of Rachel\nRachel Sector - Grid PB18",
	}
	OperationBlackSpire_AG[75] = {
		TargetName = "Rachel - Suspicious Farm",
		TargetStatic = true,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Suspicious Farm located North of Rachel\nRachel Sector - Grid PB18",
	}
	OperationBlackSpire_AG[76] = {
		TargetName = "Rachel - Armor 1",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Armored Vehicles at the Suspicious Farm North of Rachel\nRachel Sector - Grid PB18",
	}
	--Rachel Drug Farm
	OperationBlackSpire_AG[77] = {
		TargetName = "Rachel - Drug Farm",
		TargetStatic = true,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Drug Farm located at Rachel\nRachel Sector - Grid PB06",
	}
	OperationBlackSpire_AG[78] = {
		TargetName = "Rachel - Infantry 1",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Anti-Air Infantry at the Drug Farm located at Rachel\nRachel Sector - Grid PB06",
	}
	OperationBlackSpire_AG[79] = {
		TargetName = "Rachel - Trucks 1",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Trucks being loaded with Drugs at the Drug Farm located at Rachel\nRachel Sector - Grid PB06",
	}
	OperationBlackSpire_AG[80] = {
		TargetName = "Rachel - OH-58D",
		TargetStatic = true,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Drug Lord's Helicopter at the Drug Farm located at Rachel\nRachel Sector - Grid PB06",
	}
	--/////////////
	--TONOPAH NORTH
	OperationBlackSpire_AG[81] = {
		TargetName = "Tonopah North - Comms",
		TargetStatic = true,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Communications Tower at the Northern end of the Tonopah Bombing Range\nTonopah North Sector - Grid NB28",
	}
	OperationBlackSpire_AG[82] = {
		TargetName = "Tonopah North - SAM 1",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Mobile SAM at the Northern end of the Tonopah Bombing Range\nTonopah North Sector - Grid NB28",
	}
	OperationBlackSpire_AG[83] = {
		TargetName = "Tonopah North - Chemical Factory",
		TargetStatic = true,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Chemical Factory at the Northern end of the Tonopah Bombing Range\nTonopah North Sector - Grid NB28",
	}
	OperationBlackSpire_AG[84] = {
		TargetName = "Tonopah North - Chemical Refinery",
		TargetStatic = true,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Chemical Refinery at the Northern end of the Tonopah Bombing Range\nTonopah North Sector - Grid NB28",
	}
	OperationBlackSpire_AG[85] = {
		TargetName = "Tonopah North - Warehouse",
		TargetStatic = true,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Chemical Warehouse at the Northern end of the Tonopah Bombing Range\nTonopah North Sector - Grid NB28",
	}
	OperationBlackSpire_AG[86] = {
		TargetName = "Tonopah North - AAA 1",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the AAA Assets at the Northern end of the Tonopah Bombing Range\nTonopah North Sector - Grid NB28",
	}
	OperationBlackSpire_AG[87] = {
		TargetName = "Tonopah North - Infantry 1",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Anti-Air Infantry at the Northern end of the Tonopah Bombing Range\nTonopah North Sector - Grid NB28",
	}	
	--/////////////
	--TONOPAH SOUTH
	--Fake Airfield
	OperationBlackSpire_AG[88] = {
		TargetName = "Tonopah South - Tu-95MS",
		TargetStatic = true,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Tu-95 at the Bombing Range Airfield located North-East of Obsidian Butte Mountain\nTonopah South Sector - Grid NB13",
	}
	OperationBlackSpire_AG[89] = {
		TargetName = "Tonopah South - IL-76MD",
		TargetStatic = true,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the IL-76 at the Bombing Range Airfield located North-East of Obsidian Butte Mountain\nTonopah South Sector - Grid NB13",
	}
	OperationBlackSpire_AG[90] = {
		TargetName = "Tonopah South - Hangar West",
		TargetStatic = true,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Western Hangar at the Bombing Range Airfield located North-East of Obsidian Butte Mountain\nTonopah South Sector - Grid NB13",
	}
	OperationBlackSpire_AG[91] = {
		TargetName = "Tonopah South - Hangar East",
		TargetStatic = true,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Eastern Hangar at the Bombing Range Airfield located North-East of Obsidian Butte Mountain\nTonopah South Sector - Grid NB13",
	}
	OperationBlackSpire_AG[92] = {
		TargetName = "Tonopah South - Comms",
		TargetStatic = true,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Communications Tower North of the Bombing Range Airfield located North-East of Obsidian Butte Mountain\nTonopah South Sector - Grid NB13",
	}
	--Factory
	OperationBlackSpire_AG[93] = {
		TargetName = "Tonopah South - Factory",
		TargetStatic = true,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Factory located North-North-West of Obsidian Butte Mountain\nTonopah South Sector - Grid NB03",
	}
	OperationBlackSpire_AG[94] = {
		TargetName = "Tonopah South - Refinery",
		TargetStatic = true,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Refinery located North-North-West of Obsidian Butte Mountain\nTonopah South Sector - Grid NB03",
	}
	OperationBlackSpire_AG[95] = {
		TargetName = "Tonopah South - Chemical Tank",
		TargetStatic = true,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Chemical Tank located North-North-West of Obsidian Butte Mountain\nTonopah South Sector - Grid NB03",
	}
	OperationBlackSpire_AG[96] = {
		TargetName = "Tonopah South - Tech Hangar",
		TargetStatic = true,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Tech Hangar located North-North-West of Obsidian Butte Mountain\nTonopah South Sector - Grid NB03",
	}
	OperationBlackSpire_AG[97] = {
		TargetName = "Tonopah South - Boiler House",
		TargetStatic = true,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Boiler House located North-North-West of Obsidian Butte Mountain\nTonopah South Sector - Grid NB03",
	}
	--/////////////
	--TONOPAH East
	--Dead Horse Flat
	OperationBlackSpire_AG[98] = {
		TargetName = "Tonopah East - SAM 1",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Mobile SAM located at Dead Horse Flat\nTonopah East Sector - Grid NB63",
	}
	OperationBlackSpire_AG[99] = {
		TargetName = "Tonopah East - AAA 1",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the AAA Assets located at Dead Horse Flat\nTonopah East Sector - Grid NB63",
	}
	OperationBlackSpire_AG[100] = {
		TargetName = "Tonopah East - Artillery 1",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Artillery Vehicles located at Dead Horse Flat\nTonopah East Sector - Grid NB63",
	}
	OperationBlackSpire_AG[101] = {
		TargetName = "Tonopah East - Armor 1",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the T-90 Tanks located at Dead Horse Flat\nTonopah East Sector - Grid NB63",
	}
	OperationBlackSpire_AG[102] = {
		TargetName = "Tonopah East - Armor 1",
		TargetStatic = false,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Armored Vehicles located at Dead Horse Flat\nTonopah East Sector - Grid NB63",
	}
	OperationBlackSpire_AG[103] = {
		TargetName = "Tonopah East - Military HQ",
		TargetStatic = true,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Military HQ located at Dead Horse Flat\nTonopah East Sector - Grid NB63",
	}
	OperationBlackSpire_AG[104] = {
		TargetName = "Tonopah East - Military Barracks",
		TargetStatic = true,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Military Barracks located at Dead Horse Flat\nTonopah East Sector - Grid NB63",
	}
	OperationBlackSpire_AG[105] = {
		TargetName = "Tonopah East - Comms",
		TargetStatic = true,
		TargetBriefing = "Mission Update \nPrimary Objective - Destroy the Communications Tower located at Dead Horse Flat\nTonopah East Sector - Grid NB63",
	}		
		
	--Debug Code
	--[[
	trigger.action.outText("Target 1 Name: "..OperationBlackSpire_AG[1].TargetName, 15)
	trigger.action.outText("Target 1 Type: "..OperationBlackSpire_AG[1].TargetType, 15)
	trigger.action.outText(OperationBlackSpire_AG[1].TargetBriefing, 15)
	
	OperationBlackSpire_AG[1] = {}
	OperationBlackSpire_AG[1][1] = "Test Sector - Supply 1"
	OperationBlackSpire_AG[1][2] = "Unit"
	trigger.action.outText("Target 1 Name: "..OperationBlackSpire_AG[1][1], 15)
	trigger.action.outText("Target 1 Type: "..OperationBlackSpire_AG[1][2], 15)
	]]--
end

--////End Mission Target Table
--////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
--////ON DEMAND MISSION INFORMATION

local function CheckObjectiveRequest()
	
	if ( AGMissionBriefingText ~= nil ) then
		trigger.action.outText(AGMissionBriefingText, 15)
		trigger.action.outSound('That Is Our Target.ogg')
	elseif ( OperationComplete == true ) then
		trigger.action.outText("The Operation Has Been Completed, There Are No Further Objectives", 15)
	elseif ( AGMissionBriefingText == nil and OperationComplete == false ) then
		trigger.action.outText("Check Objective Request Error - No Briefing Available And Operation Is Not Completed", 15)
	else
		trigger.action.outText("Check Objective Request Error - Unexpected Result Occured", 15)
	end	
end

function TargetReport()
			
	if (AGTargetTypeStatic == false and AGMissionTarget ~=nil) then
		TargetGroup = GROUP:FindByName(AGMissionTarget)	
		
		if (GROUP:FindByName(AGMissionTarget):IsAlive() == true) then
		
			TargetRemainingUnits = Group.getByName(AGMissionTarget):getSize()	
			
			MissionPlayersBlue = SET_CLIENT:New():FilterCoalitions("blue"):FilterActive():FilterOnce()
			
			MissionPlayersBlue:ForEachClient(
				function(Client)
					if Client:IsAlive() == true then
						ClientPlayerName = Client:GetPlayerName()	  
						ClientUnitName = Client:GetName()			  
						ClientGroupName = Client:GetClientGroupName() 			
						ClientGroupID = Client:GetClientGroupID()	   	
				
						PlayerUnit = UNIT:FindByName(ClientUnitName)		
					
						PlayerCoord = PlayerUnit:GetCoordinate()
						TargetCoord = TargetGroup:GetCoordinate()
						TargetHeight = math.floor(TargetGroup:GetCoordinate():GetLandHeight() * 100)/100
						TargetHeightFt = math.floor(TargetHeight * 3.28084)
						PlayerDistance = PlayerCoord:Get2DDistance(TargetCoord)

						TargetVector = PlayerCoord:GetDirectionVec3(TargetCoord)
						TargetBearing = PlayerCoord:GetAngleRadians (TargetVector)	
					
						PlayerBR = PlayerCoord:GetBRText(TargetBearing, PlayerDistance, SETTINGS:SetImperial())
					
						--List the amount of units remaining in the group
						if (TargetRemainingUnits > 1) then
							SZMessage = "There are "..TargetRemainingUnits.." targets remaining for this mission" 
						elseif (TargetRemainingUnits == 1) then
							SZMessage = "There is "..TargetRemainingUnits.." target remaining for this mission" 
						elseif (TargetRemainingUnits == nil) then					
							SZMessage = "Unable To Determine Group Size"
						else			
							SZMessage = "Nothing to report"		
						end		
					
						BRMessage = "Target bearing "..PlayerBR
						ELEMessage = "Elevation "..TargetHeight.."m".." / "..TargetHeightFt.."ft"
					
						_SETTINGS:SetLL_Accuracy(0)
						CoordStringLLDMS = TargetCoord:ToStringLLDMS(SETTINGS:SetImperial())
						_SETTINGS:SetLL_Accuracy(3)
						CoordStringLLDDM = TargetCoord:ToStringLLDDM(SETTINGS:SetImperial())
						_SETTINGS:SetLL_Accuracy(2)
						CoordStringLLDMSDS = TargetCoord:ToStringLLDMSDS(SETTINGS:SetImperial())
						
						trigger.action.outTextForGroup(ClientGroupID, "Target Report For "..ClientPlayerName.."\n".."\n"..AGMissionBriefingText.."\n"..BRMessage.."\n"..SZMessage.."\n"..CoordStringLLDMS.."\n"..CoordStringLLDDM.."\n"..CoordStringLLDMSDS.."\n"..ELEMessage, 30)							
					else						
					end				
				end
			)
		else
			trigger.action.outText("Target Report Unavailable", 15)
		end
		
	elseif (AGTargetTypeStatic == true and AGMissionTarget ~=nil) then
		TargetGroup = STATIC:FindByName(AGMissionTarget, false)
		
		MissionPlayersBlue = SET_CLIENT:New():FilterCoalitions("blue"):FilterActive():FilterOnce()

		MissionPlayersBlue:ForEachClient(
			function(Client)
				if Client:IsAlive() == true then
					ClientPlayerName = Client:GetPlayerName()	
					ClientUnitName = Client:GetName()			
					ClientGroupName = Client:GetClientGroupName()				
					ClientGroupID = Client:GetClientGroupID()
				
					PlayerUnit = UNIT:FindByName(ClientUnitName)		
					
					PlayerCoord = PlayerUnit:GetCoordinate()
					TargetCoord = TargetGroup:GetCoordinate()
					TargetHeight = math.floor(TargetGroup:GetCoordinate():GetLandHeight() * 100)/100
					TargetHeightFt = math.floor(TargetHeight * 3.28084)
					PlayerDistance = PlayerCoord:Get2DDistance(TargetCoord)
					
					TargetVector = PlayerCoord:GetDirectionVec3(TargetCoord)
					TargetBearing = PlayerCoord:GetAngleRadians (TargetVector)	
										
					PlayerBR = PlayerCoord:GetBRText(TargetBearing, PlayerDistance, SETTINGS:SetImperial())

					BRMessage = "Target bearing "..PlayerBR
					ELEMessage = "Elevation "..TargetHeight.."m".." / "..TargetHeightFt.."ft"
					
					_SETTINGS:SetLL_Accuracy(0)
					CoordStringLLDMS = TargetCoord:ToStringLLDMS(SETTINGS:SetImperial())
					_SETTINGS:SetLL_Accuracy(3)
					CoordStringLLDDM = TargetCoord:ToStringLLDDM(SETTINGS:SetImperial())
					_SETTINGS:SetLL_Accuracy(2)
					CoordStringLLDMSDS = TargetCoord:ToStringLLDMSDS(SETTINGS:SetImperial())
					
					trigger.action.outTextForGroup(ClientGroupID, "Target Report For "..ClientPlayerName.."\n".."\n"..AGMissionBriefingText.."\n"..BRMessage.."\n"..CoordStringLLDMS.."\n"..CoordStringLLDDM.."\n"..CoordStringLLDMSDS.."\n"..ELEMessage, 30)							
				else
				end				
			end
		)		
	elseif ( OperationComplete == true ) then
		trigger.action.outText("The Operation Has Been Completed, There Are No Further Targets", 15)	
	else
		trigger.action.outText("No Target Information Available", 15)
	end
end
--////End On Demand Mission Information
--////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
--////AI SUPPORT FLIGHT FUNCTIONS

--[[

SQ BLUE SEAD F-16C
SQ BLUE CAS A-10C
SQ BLUE ASS AJS37
SQ BLUE CAP F-15C

Flags

5001 = Fighter Screen Enabled
5002 = Close Air Support Enabled
5003 = Anti-Ship Strike Enabled
5004 = SEAD Enabled
5005 = Pinpoint Strike Enabled
5891 = Drone JTAC Enabled

5010 = true if Fighter Screen active
5020 = true if Close Air Support is active
5030 = true if Anti Ship Strike is active
5040 = true if SEAD Mission is active
5050 = true if Pinpoint Strike Mission is active
5892 - true if Drone support is active

5011 = Fighter Screen Push Command
5021 = Close Air Support Push Command
5031 = Anti Ship Push Command
5041 = SEAD Mission Push Command
5051 = Pinpoint Strike Push Command

]]--

--////COMBAT AIR PATROL FIGHTER SCREEN
function RequestFighterSupport(CAPSector)
	
	if ( trigger.misc.getUserFlag(5001) == 1 ) then	
		if ( trigger.misc.getUserFlag(5010) == 0 ) then
			
			local RouteNumber = CAPSector
			
			BLUECAP1 = SPAWN
				:New( "RT BLUE CAP "..RouteNumber )
				:InitLimit( 2, 2 )
				:InitRandomizeTemplate( { "SQ BLUE CAP F-15C", "SQ BLUE CAP Su-27" } )
				:OnSpawnGroup(
					function( SpawnGroup )								
						RTBLUECAPGROUPNAME = SpawnGroup.GroupName
						RTBLUECAPGROUPID = Group.getByName(RTBLUECAPGROUPNAME):getID()												
					end
				)				
				:Spawn()
			
			trigger.action.outText("Fighter Screen Launched",60)
			--Set flag 5010 to 1
			trigger.action.setUserFlag(5010,1)	
			
		elseif ( trigger.misc.getUserFlag(5010) == 1) then
			--Check if the spawned Fighter Screen group is still alive or not
						
			if ( BLUECAP1:IsAlive() ) then
				trigger.action.outText("Fighter Screen Is Currently Active, Further Support Is Unavailable",60)
			else
				trigger.action.setUserFlag(5010,0)
				RequestFighterSupport(CAPSector)
			end			
		else			
		end
	else
		trigger.action.outText("Fighter Screen Unavailable For This Mission",60)		
	end
end

function AbortCAPMission()

	if (trigger.misc.getUserFlag(5010) == 1 ) then
		if ( GROUP:FindByName(RTBLUECAPGROUPNAME):IsAlive() ) then
			--If Alive, Perform RTB command
			local RTB = {}
			--RTB.fromWaypointIndex = 2
			RTB.goToWaypointIndex = 6
								
			local RTBTask = {id = 'SwitchWaypoint', params = RTB}
			Group.getByName(RTBLUECAPGROUPNAME):getController():setOption(0, 3)
			Group.getByName(RTBLUECAPGROUPNAME):getController():setCommand(RTBTask)	
			
			trigger.action.outText("Fighter Screen Is Returning To Base",60)
		else
			trigger.action.outText("Fighter Screen Does Not Have Fighters To Recall",60)
		end
	else
		trigger.action.outText("Fighter Screen Has Not Been Deployed",60)
	end
end

--////CLOSE AIR SUPPORT
function RequestCASSupport(CASSector)

	if ( trigger.misc.getUserFlag(5002) == 1 ) then
		if ( trigger.misc.getUserFlag(5020) == 0 ) then

			local RouteNumber = CASSector
			
			BLUECAS1 = SPAWN
				:New( "RT BLUE CAS "..RouteNumber )
				:InitLimit( 2, 2 )
				:InitRandomizeTemplate( { "SQ BLUE CAS A-10C" } ) --, "SQ BLUE CAS Su-25T"
				:OnSpawnGroup(
					function( SpawnGroup )								
						RTBLUECASGROUPNAME = SpawnGroup.GroupName
						RTBLUECASGROUPID = Group.getByName(RTBLUECASGROUPNAME):getID()												
					end
				)
				:Spawn()
			
			trigger.action.outText("Close Air Support Launched",60)
			--Set flag 5020 to 1
			trigger.action.setUserFlag(5020,1)	
			
		elseif ( trigger.misc.getUserFlag(5020) == 1) then
			--Check if the spawned Close Air Support group is still alive or not
			
			if ( BLUECAS1:IsAlive() ) then
				trigger.action.outText("Close Air Support Is Currently Active, Further Support Is Unavailable",60)
			else				
				trigger.action.setUserFlag(5020,0)
				RequestCASSupport(CASSector)
			end		
		else			
		end
	else
		trigger.action.outText("Close Air Support Unavailable For This Mission",60)
	end	
end

function AbortCASMission()

	if ( trigger.misc.getUserFlag(5020) == 1 ) then
		if ( GROUP:FindByName(RTBLUECASGROUPNAME):IsAlive() ) then
			--If Alive, Perform RTB command
			local RTB = {}
			--RTB.fromWaypointIndex = 2
			RTB.goToWaypointIndex = 5
								
			local RTBTask = {id = 'SwitchWaypoint', params = RTB}			
			Group.getByName(RTBLUECASGROUPNAME):getController():setOption(0, 3) -- (0, 4) is weapons hold, (0, 3) is return fire
			Group.getByName(RTBLUECASGROUPNAME):getController():setCommand(RTBTask)	
			
			trigger.action.outText("Close Air Support Is Returning To Base",60)
		else
			trigger.action.outText("Close Air Support Does Not Have Planes To Recall",60)
		end
	else
		trigger.action.outText("Close Air Support Has Not Been Deployed",60)
	end
end

--////ANTI-SHIPPING
function RequestASSSupport(ASSSector)
	
	if ( trigger.misc.getUserFlag(5003) == 1 ) then	
		if ( trigger.misc.getUserFlag(5030) == 0 ) then
			
			local RouteNumber = ASSSector
			
			BLUEASS1 = SPAWN
				:New( "RT BLUE ASS "..RouteNumber )
				:InitLimit( 2, 2 )
				:InitRandomizeTemplate( { "SQ BLUE ASS AJS37" } ) --"SQ BLUE ASS AJS37", "SQ BLUE ASS F/A-18C"
				:OnSpawnGroup(
					function( SpawnGroup )								
						RTBLUEASSGROUPNAME = SpawnGroup.GroupName
						RTBLUEASSGROUPID = Group.getByName(RTBLUEASSGROUPNAME):getID()												
					end
				)
				:Spawn()					
			
			trigger.action.outText("Anti-Shipping Strike Launched",60)
			--Set flag 5030 to 1
			trigger.action.setUserFlag(5030,1)		
			
		elseif ( trigger.misc.getUserFlag(5030) == 1) then
			--Check if the spawned Anti-Shipping group is still alive or not
			
			if ( BLUEASS1:IsAlive() ) then
				trigger.action.outText("Anti-Shipping Is Currently Active, Further Support Is Unavailable",60)
			else
				trigger.action.setUserFlag(5030,0)
				RequestASSSupport(ASSSector)
			end		
		else			
		end
	else
		trigger.action.outText("Anti-Shipping Strike Unavailable For This Mission",60)	
	end	
end

function AbortASSMission()

	if ( trigger.misc.getUserFlag(5030) == 1 ) then
		if ( GROUP:FindByName(RTBLUEASSGROUPNAME):IsAlive() ) then
			--If Alive, Perform RTB command
			local RTB = {}
			--RTB.fromWaypointIndex = 2
			RTB.goToWaypointIndex = 7
								
			local RTBTask = {id = 'SwitchWaypoint', params = RTB}
			Group.getByName(RTBLUEASSGROUPNAME):getController():setOption(0, 3)
			Group.getByName(RTBLUEASSGROUPNAME):getController():setCommand(RTBTask)	
			
			trigger.action.outText("Anti-Shipping Support Is Returning To Base",60)
		else
			trigger.action.outText("Anti-Shipping Support Does Not Have Planes To Recall",60)
		end
	else
		trigger.action.outText("Anti-Shipping Support Has Not Been Deployed",60)
	end
end

--////SEAD
function RequestSEADSupport(SEADSector)
	
	if ( trigger.misc.getUserFlag(5004) == 1 ) then
		if ( trigger.misc.getUserFlag(5040) == 0 ) then
			
			local RouteNumber = SEADSector
			
			BLUESEAD1 = SPAWN
				:New( "RT BLUE SEAD "..RouteNumber )
				:InitLimit( 2, 2 )
				:InitRandomizeTemplate( { "SQ BLUE SEAD F-16C", "SQ BLUE SEAD F/A-18C" } ) --"SQ BLUE SEAD Su-25T"
				:OnSpawnGroup(
					function( SpawnGroup )								
						RTBLUESEADGROUPNAME = SpawnGroup.GroupName
						RTBLUESEADGROUPID = Group.getByName(RTBLUESEADGROUPNAME):getID()	
												
					end
				)
				:Spawn()
			
			trigger.action.outText("SEAD Mission Launched",60)
			--Set flag 5040 to 1
			trigger.action.setUserFlag(5040,1)	
			
		elseif ( trigger.misc.getUserFlag(5040) == 1) then
			--Check if the spawned SEAD group is still alive or not
			
			if ( BLUESEAD1:IsAlive() ) then
				trigger.action.outText("SEAD Is Currently Active, Further Support Is Unavailable",60)
			else
				trigger.action.setUserFlag(5040,0)
				RequestSEADSupport(SEADSector)
			end		
		else			
		end
	else
		trigger.action.outText("SEAD Unavailable For This Mission",60)
	end		
end

function AbortSEADMission()

	if ( trigger.misc.getUserFlag(5040) == 1 ) then
		if ( GROUP:FindByName(RTBLUESEADGROUPNAME):IsAlive() ) then
			--If Alive, Perform RTB command
			local RTB = {}
			--RTB.fromWaypointIndex = 2
			RTB.goToWaypointIndex = 5
								
			local RTBTask = {id = 'SwitchWaypoint', params = RTB}
			Group.getByName(RTBLUESEADGROUPNAME):getController():setOption(0, 3)
			Group.getByName(RTBLUESEADGROUPNAME):getController():setCommand(RTBTask)	
			
			trigger.action.outText("SEAD Support Is Returning To Base",60)
		else
			trigger.action.outText("SEAD Support Does Not Have Planes To Recall",60)
		end
	else
		trigger.action.outText("SEAD Support Has Not Been Deployed",60)
	end
end


--////PINPOINT STRIKE
function RequestPINSupport(PinSector)
	
	if ( trigger.misc.getUserFlag(5005) == 1 ) then
		if ( trigger.misc.getUserFlag(5050) == 0 ) then
			
			PINRouteNumber = PinSector
			
			BLUEPIN1 = SPAWN
				:New( "RT BLUE PIN "..PINRouteNumber )
				:InitLimit( 2, 2 )
				:InitRandomizeTemplate( { "SQ BLUE PIN F-117A", "SQ BLUE PIN Tornado GR4", "SQ BLUE PIN F-15E" } )
				:OnSpawnGroup(
					function( SpawnGroup )								
						RTBLUEPINGROUPNAME = SpawnGroup.GroupName
						RTBLUEPINGROUPID = Group.getByName(RTBLUEPINGROUPNAME):getID()												
					end
				)
				:Spawn()
			
			trigger.action.outText("Pinpoint Strike Mission Launched",60)
			--Set flag 5050 to 1
			trigger.action.setUserFlag(5050,1)	
			
		elseif ( trigger.misc.getUserFlag(5050) == 1) then
			--Check if the spawned Pinpoint Strike group is still alive or not
			
			if ( BLUEPIN1:IsAlive() ) then
				trigger.action.outText("Pinpoint Strike Is Currently Active, Further Support Is Unavailable",60)
			else
				trigger.action.setUserFlag(5050,0)
				RequestPINSupport(PinSector)
			end		
		else			
		end
	else
		trigger.action.outText("Pinpoint Strike Unavailable For This Mission",60)
	end	
end

function AbortPINMission()

	if ( trigger.misc.getUserFlag(5050) == 1 ) then
		if ( GROUP:FindByName(RTBLUEPINGROUPNAME):IsAlive() ) then
			--If Alive, Perform RTB command
			local RTB = {}
			--RTB.fromWaypointIndex = 2
			RTB.goToWaypointIndex = 6
								
			local RTBTask = {id = 'SwitchWaypoint', params = RTB}
			Group.getByName(RTBLUEPINGROUPNAME):getController():setOption(0, 3)
			Group.getByName(RTBLUEPINGROUPNAME):getController():setCommand(RTBTask)	
			
			trigger.action.outText("Pinpoint Strike Support Is Returning To Base",60)
		else
			trigger.action.outText("Pinpoint Strike Support Does Not Have Planes To Recall",60)
		end
	else
		trigger.action.outText("Pinpoint Strike Support Has Not Been Deployed",60)
	end
end

function SEF_PinpointStrikeTargetAcquisition()
	
	--See https://wiki.hoggitworld.com/view/DCS_task_bombing for further details
	--CHECK TARGET IS IN THE SAME SECTOR THE FLIGHT WAS CALLED TO, GET DETAILS IF IT IS AND ABORT IF NOT
	if ( AGMissionTarget ~= nil and string.find(AGMissionTarget, PINRouteNumber) ) then		
		if ( AGTargetTypeStatic == true ) then
			if ( StaticObject.getByName(AGMissionTarget):isExist() == true ) then
				TargetGroupPIN = STATIC:FindByName(AGMissionTarget, false)
				TargetCoordForStrike = TargetGroupPIN:GetCoordinate():GetVec2()
					
				local target = {}
				target.point = TargetCoordForStrike
				target.expend = "Two"
				target.weaponType = 14
				target.attackQty = 1
				target.groupAttack = true
				local engage = {id = 'Bombing', params = target}
				Group.getByName(RTBLUEPINGROUPNAME):getController():pushTask(engage)
				trigger.action.outText("The Pinpoint Strike Flight Reports Target Coordinates Are Locked In And They Are Engaging!", 15)	
			else
				trigger.action.outText("Pinpoint Strike Mission Unable To Locate Target, Aborting Mission", 15)
				AbortPINMission()
			end
		elseif ( AGTargetTypeStatic == false ) then
			if ( GROUP:FindByName(AGMissionTarget):IsAlive() == true ) then
				TargetGroupPIN = GROUP:FindByName(AGMissionTarget, false)
				TargetCoordForStrike = TargetGroupPIN:GetCoordinate():GetVec2()
					
				local target = {}
				target.point = TargetCoordForStrike
				target.expend = "Two"
				target.weaponType = 14 -- See https://wiki.hoggitworld.com/view/DCS_enum_weapon_flag for other weapon launch codes
				target.attackQty = 1
				target.groupAttack = true
				local engage = {id = 'Bombing', params = target}
				Group.getByName(RTBLUEPINGROUPNAME):getController():pushTask(engage)
				trigger.action.outText("The Pinpoint Strike Flight Reports Target Coordinates Are Locked In And They Are Engaging!", 15)		
			else
				trigger.action.outText("Pinpoint Strike Mission Unable To Locate Target", 15)
				AbortPINMission()
			end
		else
			trigger.action.outText("Pinpoint Strike Mission Unable To Locate Target", 15)
			AbortPINMission()
		end
	else
		trigger.action.outText("The Pinpoint Strike Flight Reports The Mission Target Is Not In Their Designated Sector", 15)
		AbortPINMission()		
	end	
end

--////DRONE JTAC
function RequestDroneSupport(DRONESector)
	
	if ( trigger.misc.getUserFlag(5891) == 1 ) then	
		if ( trigger.misc.getUserFlag(5892) == 0 ) then
			
			local RouteNumber = DRONESector
			
			BLUEDRONE1 = SPAWN
				:New( "RT BLUE Drone "..RouteNumber )
				:InitLimit( 1, 1 )
				:InitRandomizeTemplate( { "SQ BLUE MQ-9 Reaper" } )
				:OnSpawnGroup(
					function( SpawnGroup )								
						RTBLUEDRONEGROUPNAME = SpawnGroup.GroupName
						RTBLUEDRONEGROUPID = Group.getByName(RTBLUEDRONEGROUPNAME):getID()												
					end
				)				
				:Spawn()
			
			trigger.action.outText("MQ-9 Reaper Aerial Drone Launched",60)
			--Set flag 5892 to 1
			trigger.action.setUserFlag(5892,1)	
			
		elseif ( trigger.misc.getUserFlag(5892) == 1) then
			--Check if the spawned drone is still alive or not
						
			if ( BLUEDRONE1:IsAlive() ) then
				trigger.action.outText("MQ-9 Reaper Aerial Drone Is Currently Active, Further Support Is Unavailable",60)
			else
				trigger.action.setUserFlag(5892,0)
				RequestDroneSupport(DRONESector)
			end			
		else			
		end
	else
		trigger.action.outText("MQ-9 Reaper Aerial Drone Unavailable For This Mission",60)		
	end
end

function AbortDroneMission()

	if (trigger.misc.getUserFlag(5892) == 1 ) then
		if ( GROUP:FindByName(RTBLUEDRONEGROUPNAME):IsAlive() ) then
			--If Alive, Perform RTB command
			local RTB = {}
			--RTB.fromWaypointIndex = 2
			RTB.goToWaypointIndex = 3
								
			local RTBTask = {id = 'SwitchWaypoint', params = RTB}
			Group.getByName(RTBLUEDRONEGROUPNAME):getController():setOption(0, 3)
			Group.getByName(RTBLUEDRONEGROUPNAME):getController():setCommand(RTBTask)	
			
			trigger.action.outText("MQ-9 Reaper Aerial Drone Is Returning To Base",60)
		else
			trigger.action.outText("MQ-9 Reaper Aerial Drone Is Unable To Be Recalled",60)
		end
	else
		trigger.action.outText("MQ-9 Reaper Aerial Drone Has Not Been Deployed",60)
	end
end

--////AI FLAG SWITCHES ETC
function SEF_CAPCommenceAttack()
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Fighter Screen Commence Attack", nil, function() trigger.action.setUserFlag(5011,1) end, nil)
	trigger.action.outText("Fighter Screen Push Command Available",60)
end

function SEF_CASCommenceAttack()
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Close Air Support Commence Attack", nil, function() trigger.action.setUserFlag(5021,1) end, nil)
	trigger.action.outText("Close Air Support Push Command Available",60)
end

function SEF_AntiShipCommenceAttack()
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Anti-Ship Strike Commence Attack", nil, function() trigger.action.setUserFlag(5031,1) end, nil)
	trigger.action.outText("Anti-Ship Strike Push Command Available",60)
end

function SEF_SEADCommenceAttack()
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "SEAD Commence Attack", nil, function() trigger.action.setUserFlag(5041,1) end, nil)
	trigger.action.outText("SEAD Push Command Available",60)
end

function SEF_PinpointStrikeCommenceAttack()
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Pinpoint Strike Commence Attack", nil, function() trigger.action.setUserFlag(5051,1) end, nil)
	trigger.action.outText("Pinpoint Strike Push Command Available",60)
end

function SEF_CAPRemovePush()
	missionCommands.removeItemForCoalition(coalition.side.BLUE, {[1] = nil, [2] = "Fighter Screen Commence Attack"})
	trigger.action.setUserFlag(5011,0)
end

function SEF_CASRemovePush()
	missionCommands.removeItemForCoalition(coalition.side.BLUE, {[1] = nil, [2] = "Close Air Support Commence Attack"})
	trigger.action.setUserFlag(5021,0)
end

function SEF_ASSRemovePush()
	missionCommands.removeItemForCoalition(coalition.side.BLUE, {[1] = nil, [2] = "Anti-Ship Strike Commence Attack"})
	trigger.action.setUserFlag(5031,0)
end

function SEF_SEADRemovePush()
	missionCommands.removeItemForCoalition(coalition.side.BLUE, {[1] = nil, [2] = "SEAD Commence Attack"})
	trigger.action.setUserFlag(5041,0)
end

function SEF_PINRemovePush()
	missionCommands.removeItemForCoalition(coalition.side.BLUE, {[1] = nil, [2] = "Pinpoint Strike Commence Attack"})
	trigger.action.setUserFlag(5051,0)
end

function SEF_CheckAIPushFlags( timeloop, time )	
	if ( trigger.misc.getUserFlag(5011) == 1 ) then
		timer.scheduleFunction(SEF_CAPRemovePush, 53, timer.getTime() + 1)
		return time + 2
	elseif ( trigger.misc.getUserFlag(5021) == 1 ) then
		timer.scheduleFunction(SEF_CASRemovePush, 53, timer.getTime() + 1)
		return time + 2
	elseif ( trigger.misc.getUserFlag(5031) == 1 ) then
		timer.scheduleFunction(SEF_ASSRemovePush, 53, timer.getTime() + 1)
		return time + 2
	elseif ( trigger.misc.getUserFlag(5041) == 1 ) then
		timer.scheduleFunction(SEF_SEADRemovePush, 53, timer.getTime() + 1)
		return time + 2
	elseif ( trigger.misc.getUserFlag(5051) == 1 ) then
		timer.scheduleFunction(SEF_PINRemovePush, 53, timer.getTime() + 1)
		return time + 2
	else
		return time + 2
	end
end

--////End Support Functions
--////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
--////Radio Menu 

function SEF_RadioMenuSetup()
	--////Set Up Menu
	-- table missionCommands.addSubMenuForCoalition(enum coalition.side, string name , table path)
	-- table missionCommands.addCommand(string name, table/nil path, function functionToRun , any anyArguement)
	-- table missionCommands.addCommandForCoalition(enum coalition.side, string name, table/nil path, function functionToRun , any anyArguement)

	--////SECTOR NAMES
	--62A
	--Area 51
	--Caliente Alpha
	--Caliente Charlie
	--Hoover Dam
	--Pahute
	--Rachel
	--Tonopah East
	--Tonopah North
	--Tonopah South	
	
	--////Setup Submenu For Support Requests
	SupportMenuMain = missionCommands.addSubMenuForCoalition(coalition.side.BLUE, "Request Support", nil)
	SupportMenuAbort = missionCommands.addSubMenuForCoalition(coalition.side.BLUE, "Abort Directives", nil)
	SupportMenuCAP  = missionCommands.addSubMenuForCoalition(coalition.side.BLUE, "Request Fighter Support", SupportMenuMain)
	SupportMenuCAS  = missionCommands.addSubMenuForCoalition(coalition.side.BLUE, "Request Close Air Support", SupportMenuMain)
	SupportMenuSEAD = missionCommands.addSubMenuForCoalition(coalition.side.BLUE, "Request SEAD Support", SupportMenuMain)
	--SupportMenuASS = missionCommands.addSubMenuForCoalition(coalition.side.BLUE, "Request Anti-Shipping Support", SupportMenuMain)
	SupportMenuPIN = missionCommands.addSubMenuForCoalition(coalition.side.BLUE, "Request Pinpoint Strike", SupportMenuMain)
	SupportMenuDrone = missionCommands.addSubMenuForCoalition(coalition.side.BLUE, "Request MQ-9 Reaper Drone", SupportMenuMain)
	
	--////Setup Menu Option To Get The Current Objective
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Check Current Objective", nil, function() CheckObjectiveRequest() end, nil)	
	--////Target Report to get target numbers and coordinates 
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Target Report", nil, function() TargetReport() end, nil)
	--////Drop Smoke On The Target
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Smoke Current Objective", nil, function() SEF_TargetSmoke() end, nil)
	--////The Wild West Pistol Duel
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Wild West Pistol Duel", nil, function() RequestGunDogfight() end, nil)
	
	--////AI Support Flights Mission Abort Codes
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Abort Mission Fighter Screen", SupportMenuAbort, function() AbortCAPMission() end, nil)	
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Abort Mission Close Air Support", SupportMenuAbort, function() AbortCASMission() end, nil)
	--missionCommands.addCommandForCoalition(coalition.side.BLUE, "Abort Mission Anti-Shipping", SupportMenuAbort, function() AbortASSMission() end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Abort Mission SEAD", SupportMenuAbort, function() AbortSEADMission() end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Abort Mission Pinpoint Strike", SupportMenuAbort, function() AbortPINMission() end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Abort Mission MQ-9 Reaper Drone", SupportMenuAbort, function() AbortDroneMission() end, nil)	
	
	--////Black Spire Mission Options
	BlackSpireOptions = missionCommands.addSubMenuForCoalition(coalition.side.BLUE, "Black Spire Options", nil)
	BlackSpireCAPOptions = missionCommands.addSubMenuForCoalition(coalition.side.BLUE, "Black Spire CAP Options", BlackSpireOptions)
	BlackSpireSNDOptions = missionCommands.addSubMenuForCoalition(coalition.side.BLUE, "Black Spire Sound Options", BlackSpireOptions)
	BlackSpireCAPNellis = missionCommands.addCommandForCoalition(coalition.side.BLUE, "Enable Nellis Vipers", BlackSpireCAPOptions, function() SEF_NellisCAP() end, nil)
	BlackSpireFleetCats = missionCommands.addCommandForCoalition(coalition.side.BLUE, "Enable Nellis Tomcats", BlackSpireCAPOptions, function() SEF_FleetTomcats() end, nil)
	BlackSpireFleetBugs = missionCommands.addCommandForCoalition(coalition.side.BLUE, "Enable Nellis Hornets", BlackSpireCAPOptions, function() SEF_FleetHornets() end, nil)
	BlackSpireToggleFiringSounds = missionCommands.addCommandForCoalition(coalition.side.BLUE, "Toggle Firing Sounds", BlackSpireSNDOptions, function() SEF_ToggleFiringSounds() end, nil)
	--BlackSpireDisableShips  = missionCommands.addCommandForCoalition(coalition.side.BLUE, "Naval Ships AI Off", BlackSpireOptions, function() SEF_DisableShips() end, nil)
	BlackSpireDefenceCheck  = missionCommands.addCommandForCoalition(coalition.side.BLUE, "Check Defence Networks", BlackSpireOptions, function() SEF_CheckDefenceNetwork() end, nil)
	BlackSpireAirfieldCheck  = missionCommands.addCommandForCoalition(coalition.side.BLUE, "Check Airfield Status", BlackSpireOptions, function() SEF_CheckAirfieldStatus() end, nil)
	BlackSpireSkipScenario  = missionCommands.addCommandForCoalition(coalition.side.BLUE, "Skip This Mission", BlackSpireOptions, function() SEF_SkipScenario() end, nil)	
	
	--////CAP Support Sector List
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector 62A", SupportMenuCAP, function() RequestFighterSupport('62A') end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Area 51", SupportMenuCAP, function() RequestFighterSupport('Area 51') end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Caliente Alpha", SupportMenuCAP, function() RequestFighterSupport('Caliente Alpha') end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Caliente Charlie", SupportMenuCAP, function() RequestFighterSupport('Caliente Charlie') end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Hoover Dam", SupportMenuCAP, function() RequestFighterSupport('Hoover Dam') end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Pahute", SupportMenuCAP, function() RequestFighterSupport('Pahute') end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Rachel", SupportMenuCAP, function() RequestFighterSupport('Rachel') end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Tonopah East", SupportMenuCAP, function() RequestFighterSupport('Tonopah East') end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Tonopah North", SupportMenuCAP, function() RequestFighterSupport('Tonopah North') end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Tonopah South", SupportMenuCAP, function() RequestFighterSupport('Tonopah South') end, nil)
	
	--SupportMenuCAP2 = missionCommands.addSubMenuForCoalition(coalition.side.BLUE, "Other Sectors", SupportMenuCAP)
	
	--missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Seerik", SupportMenuCAP2, function() RequestFighterSupport('Seerik') end, nil)
	--missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Bandar-e-Jask", SupportMenuCAP2, function() RequestFighterSupport('Bandar-e-Jask') end, nil)
	
	--////CAS Support Sector List
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector 62A", SupportMenuCAS, function() RequestCASSupport('62A') end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Area 51", SupportMenuCAS, function() RequestCASSupport('Area 51') end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Caliente Alpha", SupportMenuCAS, function() RequestCASSupport('Caliente Alpha') end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Caliente Charlie", SupportMenuCAS, function() RequestCASSupport('Caliente Charlie') end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Hoover Dam", SupportMenuCAS, function() RequestCASSupport('Hoover Dam') end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Pahute", SupportMenuCAS, function() RequestCASSupport('Pahute') end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Rachel", SupportMenuCAS, function() RequestCASSupport('Rachel') end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Tonopah East", SupportMenuCAS, function() RequestCASSupport('Tonopah East') end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Tonopah North", SupportMenuCAS, function() RequestCASSupport('Tonopah North') end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Tonopah South", SupportMenuCAS, function() RequestCASSupport('Tonopah South') end, nil)
	
	--SupportMenuCAS2 = missionCommands.addSubMenuForCoalition(coalition.side.BLUE, "Other Sectors", SupportMenuCAS)
	
	--missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Seerik", SupportMenuCAS2, function() RequestCASSupport('Seerik') end, nil)
	--missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Bandar-e-Jask", SupportMenuCAS2, function() RequestCASSupport('Bandar-e-Jask') end, nil)
	
	--////SEAD Support Sector List
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector 62A", SupportMenuSEAD, function() RequestSEADSupport('62A') end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Area 51", SupportMenuSEAD, function() RequestSEADSupport('Area 51') end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Caliente Alpha", SupportMenuSEAD, function() RequestSEADSupport('Caliente Alpha') end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Caliente Charlie", SupportMenuSEAD, function() RequestSEADSupport('Caliente Charlie') end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Hoover Dam", SupportMenuSEAD, function() RequestSEADSupport('Hoover Dam') end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Pahute", SupportMenuSEAD, function() RequestSEADSupport('Pahute') end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Rachel", SupportMenuSEAD, function() RequestSEADSupport('Rachel') end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Tonopah East", SupportMenuSEAD, function() RequestSEADSupport('Tonopah East') end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Tonopah North", SupportMenuSEAD, function() RequestSEADSupport('Tonopah North') end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Tonopah South", SupportMenuSEAD, function() RequestSEADSupport('Tonopah South') end, nil)
	
	--SupportMenuSEAD2 = missionCommands.addSubMenuForCoalition(coalition.side.BLUE, "Other Sectors", SupportMenuSEAD)
	
	--missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Seerik", SupportMenuSEAD2, function() RequestSEADSupport('Seerik') end, nil)
	--missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Bandar-e-Jask", SupportMenuSEAD2, function() RequestSEADSupport('Bandar-e-Jask') end, nil)
	
	--////ANTI-SHIP Support Sector List
	--missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Abu Musa Island", SupportMenuASS, function() RequestASSSupport('Abu Musa') end, nil)
	--missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Sirri Island", SupportMenuASS, function() RequestASSSupport('Sirri') end, nil)
	--missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Bandar Lengeh", SupportMenuASS, function() RequestASSSupport('Bandar Lengeh') end, nil)
	--missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Qeshm Island", SupportMenuASS, function() RequestASSSupport('Qeshm') end, nil)
	--missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Havadarya", SupportMenuASS, function() RequestASSSupport('Havadarya') end, nil)
	--missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Bandar-e-Jask", SupportMenuASS, function() RequestASSSupport('Bandar-e-Jask') end, nil)
	
	--////PIN Support Sector List
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector 62A", SupportMenuPIN, function() RequestPINSupport('62A') end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Area 51", SupportMenuPIN, function() RequestPINSupport('Area 51') end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Caliente Alpha", SupportMenuPIN, function() RequestPINSupport('Caliente Alpha') end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Caliente Charlie", SupportMenuPIN, function() RequestPINSupport('Caliente Charlie') end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Hoover Dam", SupportMenuPIN, function() RequestPINSupport('Hoover Dam') end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Pahute", SupportMenuPIN, function() RequestPINSupport('Pahute') end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Rachel", SupportMenuPIN, function() RequestPINSupport('Rachel') end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Tonopah East", SupportMenuPIN, function() RequestPINSupport('Tonopah East') end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Tonopah North", SupportMenuPIN, function() RequestPINSupport('Tonopah North') end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Tonopah South", SupportMenuPIN, function() RequestPINSupport('Tonopah South') end, nil)
	
	--SupportMenuPIN2 = missionCommands.addSubMenuForCoalition(coalition.side.BLUE, "Other Sectors", SupportMenuPIN)
	
	--missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Seerik", SupportMenuPIN2, function() RequestPINSupport('Seerik') end, nil)
	--missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Bandar-e-Jask", SupportMenuPIN2, function() RequestPINSupport('Bandar-e-Jask') end, nil)

	--////Drone Support Sector List
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector 62A", SupportMenuDrone, function() RequestDroneSupport('62A') end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Area 51", SupportMenuDrone, function() RequestDroneSupport('Area 51') end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Caliente Alpha", SupportMenuDrone, function() RequestDroneSupport('Caliente Alpha') end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Caliente Charlie", SupportMenuDrone, function() RequestDroneSupport('Caliente Charlie') end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Hoover Dam", SupportMenuDrone, function() RequestDroneSupport('Hoover Dam') end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Pahute", SupportMenuDrone, function() RequestDroneSupport('Pahute') end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Rachel", SupportMenuDrone, function() RequestDroneSupport('Rachel') end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Tonopah East", SupportMenuDrone, function() RequestDroneSupport('Tonopah East') end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Tonopah North", SupportMenuDrone, function() RequestDroneSupport('Tonopah North') end, nil)
	missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Tonopah South", SupportMenuDrone, function() RequestDroneSupport('Tonopah South') end, nil)
	
	--SupportMenuDrone2 = missionCommands.addSubMenuForCoalition(coalition.side.BLUE, "Other Sectors", SupportMenuDrone)
	
	--missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Seerik", SupportMenuDrone2, function() RequestDroneSupport('Seerik') end, nil)
	--missionCommands.addCommandForCoalition(coalition.side.BLUE, "Sector Bandar-e-Jask", SupportMenuDrone2, function() RequestDroneSupport('Bandar-e-Jask') end, nil)	
end	


--////End Radio Menu Functions
--////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
--////NAVAL FUNCTIONS

function SEF_ROEWeaponFreeNavy()	
	Group.getByName("CVN-74 John C. Stennis"):getController():setOption(0, 2)
	--trigger.action.outText("Navy ROE Set To Weapons Free", 15)
end
						
function SEF_ROEHoldNavy()	
	Group.getByName("CVN-74 John C. Stennis"):getController():setOption(0, 4)
	--trigger.action.outText("Navy ROE Set Back To Weapons Hold", 15)
end

function SEF_NavyShipTargeting()		
	SEF_ROEWeaponFreeNavy()	
	timer.scheduleFunction(SEF_ROEHoldNavy, {}, timer.getTime() + 5) 	
end

function SEF_CarrierDefenceZone()
	CarrierDefenceZone = ZONE_GROUP:New("Carrier", GROUP:FindByName( "CVN-74 John C. Stennis" ), 40000)		
end

function SEF_CarrierDefenceZoneScanner(Timeloop, time)
	--trigger.action.outText("Carrier Group Is Scanning For Targets", 15)
	ScanResult = CarrierDefenceZone:Scan( { Unit.Category.AIRPLANE, Unit.Category.HELICOPTER } )
	RedPresense = CarrierDefenceZone:IsSomeInZoneOfCoalition(coalition.side.RED)
	DefenceZoneCount = 0
			
	if ( RedPresense == true ) then				
		SET_CARRIERDEFENCE = SET_UNIT:New():FilterCoalitions( "red" ):FilterCategories({"helicopter","plane"}):FilterOnce()		
		SET_CARRIERDEFENCE:ForEachUnitCompletelyInZone( CarrierDefenceZone, function ( GroupObject )
			DefenceZoneCount = DefenceZoneCount + 1
			end
		)		
		if ( DefenceZoneCount > 1 ) then
			--trigger.action.outText("Carrier Group Has Detected "..DefenceZoneCount.." Targets In Their Airspace", 15)			
			SEF_NavyShipTargeting()
			return time + 20			
		elseif ( DefenceZoneCount == 1 ) then
			--trigger.action.outText("Carrier Group Has Detected "..DefenceZoneCount.." Target In Their Airspace", 15)			
			SEF_NavyShipTargeting()
			return time + 20
		else
			return time + 20
		end		
	else				
		return time + 20
	end	
end

--////End Naval Functions
--////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
--////OVERRIDE FUNCTIONS

function SEF_DisableShips()
	
	--SWITCH NAVAL VESSEL AI OFF
	--[[
	Group.getByName("Abu Musa - Navy 1"):getController():setOnOff(false)
	Group.getByName("Bandar Lengeh - Navy 1"):getController():setOnOff(false)
	Group.getByName("Bandar-e-Jask - Navy 1"):getController():setOnOff(false)
	Group.getByName("Havadarya - Navy 1"):getController():setOnOff(false)
	Group.getByName("Havadarya - Navy 2"):getController():setOnOff(false)
	Group.getByName("Qeshm Island - Navy 1"):getController():setOnOff(false)
	Group.getByName("Qeshm Island - Navy 2"):getController():setOnOff(false)
	Group.getByName("Sirri Island - Navy 1"):getController():setOnOff(false)
	Group.getByName("Tunb Island - Navy 1"):getController():setOnOff(false)
	Group.getByName("Qeshm Island - Navy 2"):getController():setOnOff(false)	
	]]--
	trigger.action.outText("Naval Vessel AI is now off", 15)
end

function SEF_ToggleFiringSounds()

	if ( OnShotSoundsEnabled == 0 ) then
		OnShotSoundsEnabled = 1
		trigger.action.outText("Firing Sounds Are Now Enabled", 15)
	elseif ( OnShotSoundsEnabled == 1 ) then
		OnShotSoundsEnabled = 0
		trigger.action.outText("Firing Sounds Are Now Disabled", 15)
	else		
	end
end

--////End Override Functions
--////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
--////RED BOMBER ATTACK FUNCTIONS

--[[

--TEMPLATES
SQ RUS Tu-95MS
SQ RUS Tu-160				
SQ RUS Su-24				
SQ RUS Tu-22M3				
SQ IRN Su-25
	
--ROUTES	
RT RED PIN 1
RT RED PIN 2

]]--

function SEF_RedBomberAttack()	
	
	if ( trigger.misc.getUserFlag(5006) == 1 ) then
		if ( trigger.misc.getUserFlag(5070) == 0 ) then
			
			local RouteNumber = math.random(1,2)
			
			REDBomberTarget = "RED Bomber Target "..RouteNumber
			
			REDPIN1 = SPAWN
				:New( "RT RED PIN "..RouteNumber )
				:InitLimit( 2, 1 )
				:InitRandomizeTemplate( { "SQ RUS Tu-95MS", "SQ RUS Tu-160", "SQ RUS Su-24M", "SQ RUS Tu-22M3", "SQ IRN Su-25" } )
				:OnSpawnGroup(
					function( SpawnGroup )								
						RTREDPINGROUPNAME = SpawnGroup.GroupName
						RTREDPINGROUPID = Group.getByName(RTREDPINGROUPNAME):getID()												
					end
				)
				:Spawn()
			
			--trigger.action.outText("Mission Update \nEnemy Bombers Approaching",60)
			--Set flag 5070 to 1
			trigger.action.setUserFlag(5070,1)	
			
		elseif ( trigger.misc.getUserFlag(5070) == 1) then
			--Check if the spawned Pinpoint Strike group is still alive or not
			
			if ( REDPIN1:IsAlive() ) then
				--Do nothing as bombers are still active
			else
				trigger.action.setUserFlag(5070,0)
				SEF_RedBomberAttack()
			end		
		else			
		end
	else
		trigger.action.outText("Enemy Bomber Missions Currently Disabled",60)
	end
end

function SEF_RedBomberScheduler(timeloop, time)

	if (trigger.misc.getUserFlag(5006) == 1) then
		SEF_RedBomberAttack()		
		
		return time + math.random(1800, 2700) --Initiate between 30 minutes and 45 minutes	
	else		
	end
end

function SEF_REDBomberTargetAcquisition()
	
	TargetGroupREDPIN = ZONE:FindByName(REDBomberTarget) 
	TargetCoordForREDStrike = TargetGroupREDPIN:GetCoordinate():GetVec2()
			
	local target = {}
		target.point = TargetCoordForREDStrike
		target.expend = "Four"
		target.weaponType = 2956984318
		target.attackQty = 1
		target.groupAttack = true					
										
	local engage = {id = 'AttackMapObject', params = target}
	Group.getByName(RTREDPINGROUPNAME):getController():pushTask(engage) -- :setTask(engage)
					
	--////Launch Codes
	--Any ASM = 4161536
	--Any AG Weapon = 2956984318
	
	--[[
		Bombing = { 
			id = 'AttackMapObject', 
			params = { 
				point = Vec2,
				weaponType = number, 
				expend = enum AI.Task.WeaponExpend,
				attackQty = number, 
				direction = Azimuth, 
				groupAttack = boolean, 
			} 
		}
	]]--
end

--////End Red Bomber Functions
--////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
--////BLUE AWACS/TANKER SPAWN

function SEF_BLUEAwacsSpawn()	
			
	BLUEAWACS = SPAWN
		:New( "RT AWACS BLUE" )
		:InitLimit( 1, 1 )
		:InitRandomizeTemplate( { "SQ BLUE E-3A" } )
		
		:OnSpawnGroup(
			function( SpawnGroup )								
				RTBLUEAWACSGROUPNAME = SpawnGroup.GroupName
				RTBLUEAWACSGROUPID = Group.getByName(RTBLUEAWACSGROUPNAME):getID()												
			end
		)		
		:Spawn()		
end

function SEF_BLUETexacoSpawn()	
			
	BLUETEXACO = SPAWN
		:New( "RT TEXACO" )
		:InitLimit( 1, 1 )
		:InitRandomizeTemplate( { "SQ BLUE KC-135MPRS" } )
		
		:OnSpawnGroup(
			function( SpawnGroup )								
				RTBLUETEXACOGROUPNAME = SpawnGroup.GroupName
				RTBLUETEXACOGROUPID = Group.getByName(RTBLUETEXACOGROUPNAME):getID()												
			end
		)		
		:Spawn()		
end

function SEF_BLUEShellSpawn()	
			
	BLUESHELL = SPAWN
		:New( "RT SHELL" )
		:InitLimit( 1, 1 )
		:InitRandomizeTemplate( { "SQ BLUE KC-135" } )
		
		:OnSpawnGroup(
			function( SpawnGroup )								
				RTBLUESHELLGROUPNAME = SpawnGroup.GroupName
				RTBLUESHELLGROUPID = Group.getByName(RTBLUESHELLGROUPNAME):getID()												
			end
		)		
		:Spawn()
end

function SEF_BLUEAWACSRTBMessage()
	trigger.action.outText("AWACS Is Returning To Base",60)
end

function SEF_BLUETexacoRTBMessage()
	trigger.action.outText("Tanker Texaco Is Returning To Base",60)
end

function SEF_BLUEShellRTBMessage()
	trigger.action.outText("Tanker Shell Is Returning To Base",60)
end

--////End Blue Awacs/Tankers Spawn
--////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
--////TARGET SMOKE FUNCTIONS

function SEF_TargetSmokeLock()
	TargetSmokeLockout = 1
end

function SEF_TargetSmokeUnlock()
	TargetSmokeLockout = 0
end

function SEF_TargetSmoke()
	
	if ( TargetSmokeLockout == 0 ) then
		if ( AGTargetTypeStatic == false and AGMissionTarget ~= nil ) then
			--TARGET IS NOT STATIC					
			if ( GROUP:FindByName(AGMissionTarget):IsAlive() == true ) then
				--GROUP VALID
				SEFTargetSmokeGroupCoord = GROUP:FindByName(AGMissionTarget):GetCoordinate()
				SEFTargetSmokeGroupCoord:SmokeRed()
				--SEFTargetSmokeGroupCoord:SmokeBlue()
				--SEFTargetSmokeGroupCoord:SmokeGreen()
				--SEFTargetSmokeGroupCoord:SmokeOrange()
				--SEFTargetSmokeGroupCoord:SmokeWhite()
				trigger.action.outSound('Target Smoke.ogg')
				trigger.action.outText("Target Has Been Marked With Red Smoke", 15)
				SEF_TargetSmokeLock()
				timer.scheduleFunction(SEF_TargetSmokeUnlock, 53, timer.getTime() + 300)				
			else			
				trigger.action.outText("Target Smoke Currently Unavailable - Unable To Acquire Target Group", 15)						
			end		
		elseif ( AGTargetTypeStatic == true and AGMissionTarget ~= nil ) then		
			--TARGET IS STATIC		
			if ( StaticObject.getByName(AGMissionTarget) ~= nil and StaticObject.getByName(AGMissionTarget):isExist() == true ) then
				--STATIC IS VALID
				SEFTargetSmokeStaticCoord = STATIC:FindByName(AGMissionTarget):GetCoordinate()
				SEFTargetSmokeStaticCoord:SmokeRed()
				--SEFTargetSmokeStaticCoord:SmokeBlue()
				--SEFTargetSmokeStaticCoord:SmokeGreen()
				--SEFTargetSmokeStaticCoord:SmokeOrange()
				--SEFTargetSmokeStaticCoord:SmokeWhite()				
				trigger.action.outSound('Target Smoke.ogg')
				trigger.action.outText("Target Has Been Marked With Red Smoke", 15)
				SEF_TargetSmokeLock()
				timer.scheduleFunction(SEF_TargetSmokeUnlock, 53, timer.getTime() + 300)				
			else
				trigger.action.outText("Target Smoke Currently Unavailable - Unable To Acquire Target Building", 15)	
			end			
		else		
			trigger.action.outText("Target Smoke Currently Unavailable - No Valid Targets", 15)
		end
	else
		trigger.action.outText("Target Smoke Currently Unavailable - Smoke Shells Are Being Reloaded", 15)
	end	
end

--////End Target Smoke Functions
--////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
--////OTHER FUNCTIONS

function SEF_CheckDefenceNetwork()
	trigger.action.outText("Allied Defence Network Consists Of "..BLUEDetectionSetGroup:Count().." Groups\nEnemy Defence Network Consists Of "..REDDetectionSetGroup:Count().." Groups", 15)

	--BLUEDetectionSetGroup:ForEachGroup(
	--	function(BlueDefenceGroupCheck)
	--		BlueDefenceGroupName = BlueDefenceGroupCheck:GetName()			
	--		trigger.action.outText(BlueDefenceGroupName, 60)			
	--	end
	--)	
end

function SEF_CheckAirfieldStatus()
	trigger.action.outText("Airfield Status Report".."\n\n"..TonopahStatus.."\n"..PahuteMesaStatus.."\n"..LincolnStatus, 10)
end

--////GUNSLINGERS!
function RequestGunDogfight()
	
	if ( trigger.misc.getUserFlag(6110) == 1 ) then	
		if ( trigger.misc.getUserFlag(6111) == 0 ) then
			
			REDGUNSLINGER1 = SPAWN
				:New( "RT RED GUNSLINGER" )
				:InitLimit( 1, 1 )
				:InitRandomizeTemplate( { "SQ RED F/A-18C GUNS", "SQ RED F-14B GUNS", "SQ RED F-16CM bl.50 GUNS", "SQ RED JF-17 GUNS", 
										  "SQ RED F-5E-3 GUNS", "SQ RED M-2000C GUNS", "SQ RED F-15C GUNS", "SQ RED MiG-21Bis GUNS", "SQ RED MiG-29A GUNS", 
										  "SQ RED Su-27 GUNS", "SQ RED Su-33 GUNS", "SQ RED MiG-23MLD GUNS" } )
				:OnSpawnGroup(
					function( SpawnGroup )								
						RTREDGUNSLINGERGROUPNAME = SpawnGroup.GroupName
						RTREDGUNSLINGERGROUPID = Group.getByName(RTREDGUNSLINGERGROUPNAME):getID()												
					end
				)				
				:Spawn()
			
			trigger.action.outText("A Gunslinger Emerges In The Wild West! Find Him South Of Eagle Crags! Grid MV90",60)
			--Set flag 6111 to 1
			trigger.action.setUserFlag(6111,1)	
			
		elseif ( trigger.misc.getUserFlag(6111) == 1) then
			--Check if the spawned Gunfighter is still alive or not
						
			if ( REDGUNSLINGER1:IsAlive() ) then
				trigger.action.outText("A Gunslinger Is Currently Active, Further Gunslinger's Are Unavailable",60)
			else
				trigger.action.setUserFlag(6111,0)
				RequestGunDogfight()
			end			
		else			
		end
	else
		trigger.action.outText("Gunslinger's Currently Unavailable",60)		
	end
end

function DespawnGunslinger()
	if ( GROUP:FindByName(RTREDGUNSLINGERGROUPNAME):IsAlive() ) then
		Group.getByName(RTREDGUNSLINGERGROUPNAME):destroy()
	else
	end
end

--////End Other Functions
--////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
--////MAIN

		--////GLOBAL VARIABLE INITIALISATION	
		NumberOfCompletedMissions = 0
		TotalScenarios = 105
		OperationComplete = false
		OnShotSoundsEnabled = 1
		SoundLockout = 0
		TargetSmokeLockout = 0		
				
		--////ENABLE CAP/CAS/ASS/SEAD/PIN/DRONE
		trigger.action.setUserFlag(5001,1)
		trigger.action.setUserFlag(5002,1)
		trigger.action.setUserFlag(5003,1)
		trigger.action.setUserFlag(5004,1)
		trigger.action.setUserFlag(5005,1)
		trigger.action.setUserFlag(5891,1)
		--////ENABLE RED BOMBER ATTACKS
		trigger.action.setUserFlag(5006,1)
		--////ENABLE WILD WEST PISTOL DUEL
		trigger.action.setUserFlag(6110,1)
		
		--////FUNCTIONS
		SEF_InitializeMissionTable()		
		SEF_MissionSelector()
		SEF_RadioMenuSetup()
		SEF_BLUEAwacsSpawn()
		SEF_BLUETexacoSpawn()
		SEF_BLUEShellSpawn()
		--SEF_CarrierDefenceZone()
		
		--////SCHEDULERS
		--AI FLIGHT PUSH FLAGS
		timer.scheduleFunction(SEF_CheckAIPushFlags, 53, timer.getTime() + 1)
		--MISSION TARGET STATUS
		timer.scheduleFunction(SEF_MissionTargetStatus, 53, timer.getTime() + 10)
		--RED BOMBER ATTACKS - WAIT 10-15 MINUTES BEFORE STARTING
		--timer.scheduleFunction(SEF_RedBomberScheduler, 53, timer.getTime() + math.random(600, 900))
		--CARRIER DEFENCE ZONE SCANNER - WAIT 5 MINUTES BEFORE STARTING
		--timer.scheduleFunction(SEF_CarrierDefenceZoneScanner, 53, timer.getTime() + 300)				
	
--////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

--[[

////SECTORS

62A
Area 51
Caliente Alpha
Caliente Charlie
Hoover Dam
Pahute
Rachel
Tonopah East
Tonopah North
Tonopah South

////HOOVER Dam

Hoover Dam - AAA 1						QV08	Hoover Dam Sector
Hoover Dam - Comms						QV08	Hoover Dam Sector
Hoover Dam - Iglas 1					QV08	Hoover Dam Sector

////SAMS MAJOR SITES

62A - SA-2 Site 3						PA48	Sector 62A
Tonopah South - SA-10 Site 1			NB12	Sector Tonopah South
Tonopah North - SA-3 Site 2				NB06	Sector Tonopah North
Tonopah South - SA-3 Site 3				NB13	Sector Tonopah South
Tonopah North - SA-2 Site 4				NB06	Sector Tonopah North
Tonopah South - SA-2 Site 5				NB13	Sector Tonopah South
Tonopah South - SA-2 Site 6				NB12	Sector Tonopah South
Tonopah East - SA-2 Site 7				NB63	Sector Tonopah East
Tonopah East - SA-2 Site 8				NB64	Sector Tonopah East
Tonopah North - SA-2 Site 9				NB37	Sector Tonopah North

////SUPPLY

62A - Site 3 Supply 1					PA48	Sector 62A
Tonopah South - Site 1 Supply 1			NB12	Sector Tonopah South
Tonopah North - Site 2 Supply 1			NB06	Sector Tonopah North
Tonopah South - Site 3 Supply 1			NB13	Sector Tonopah South
Tonopah North - Site 4 Supply 1			NB06	Sector Tonopah North
Tonopah South - Site 5 Supply 1			NB13	Sector Tonopah South
Tonopah South - Site 6 Supply 1			NB12	Sector Tonopah South
Tonopah East - Site 7 Supply 1			NB63	Sector Tonopah East
Tonopah East - Site 8 Supply 1			NB64	Sector Tonopah East
Tonopah North - Site 9 Supply 1			NB37	Sector Tonopah North

////EWR

Caliente Charlie - EWR Cedar Range		QB45
Area 51 - EWR Jumbled Hills				PB21/22
Caliente Alpha - EWR Pahroc				PB75					
Pahute - EWR Timber Mountain			NB40

////CALIENTE Alpha

Caliente Alpha - Research Hangar		PB55	Sector Caliente Alpha
Caliente Alpha - Suspicious Transport	PB55	Sector Caliente Alpha
Caliente Alpha - Suspicious Container	PB55	Sector Caliente Alpha
Caliente Alpha - Comms					PB55	Sector Caliente Alpha
Caliente Alpha - Infantry 1				PB55
Caliente Alpha - Suspicious House		PB55
Caliente Alpha - SAM 1					PB65
Caliente Alpha - SAM 2					PB95
Caliente Alpha - AAA 1					PB95
Caliente Alpha - Hideout				PB95
Caliente Alpha - Infantry 2				PB95
Caliente Alpha - Supply 1				PB95

////CALIENTE CHARLIE

Caliente Charlie - Armor 1				QB57
Caliente Charlie - SAM 1				QB57
Caliente Charlie - Supply 1				QB57
Caliente Charlie - AAA 1				QB57
Caliente Charlie - Comms				QB46

////AREA 51

Area 51 - SAM 1							PB02	Sector Area 51
Area 51 - Drone Control Tower			PB02	Sector Area 51
Area 51 - AAA 1							PB02	Sector Area 51
Area 51 - Drone (Static)				PB02	Sector Area 51
Area 51 - Drone Hangar					PB02	Sector Area 51
Area 51 - Supply 1						PB02	Sector Area 51
Area 51 - Supply 2 (Fuel)				PB02	Sector Area 51
Area 51 - AH-64D (Static)				PB02	Sector Area 51
Area 51 - Tank Hangar					NB93	Sector Area 51
Area 51 - Armor 1 (Merkava Mk.4)		NB93	Sector Area 51
Area 51 - SAM 2							NB93	Sector Area 51
Area 51 - Comms							NB93	Sector Area 51
Area 51 - AAA 2							NB93	Sector Area 51
Area 51 - Supply 3						NB93	Sector Area 51

////RACHEL

Rachel - Spider							PB25	Sector Rachel
Rachel - SAM 1 (SA-13)					PB25	Sector Rachel
Rachel - AAA 1							PB25	Sector Rachel
Rachel - Supply 1						PB25	Sector Rachel
Rachel - SAM 2 (SA-8)					PB18	Sector Rachel
Rachel - AAA 2							PB18	Sector Rachel
Rachel - Supply 2						PB18	Sector Rachel
Rachel - Suspicious Farm				PB18	Sector Rachel
Rachel - Armor 1 (BTR 80's)				PB18	Sector Rachel
Rachel - Drug Farm						PB06	Sector Rachel
Rachel - Infantry 1						PB06	Sector Rachel
Rachel - Trucks 1						PB06	Sector Rachel
Rachel - OH-58D							PB06	Sector Rachel

////TONOPAH NORTH

Tonopah North - Comms					NB28	Sector Tonopah North
Tonopah North - SAM 1 (SA-19)			NB28	Sector Tonopah North
Tonopah North - Chemical Factory		NB28	Sector Tonopah North
Tonopah North - Chemical Refinery		NB28	Sector Tonopah North
Tonopah North - Warehouse				NB28	Sector Tonopah North
Tonopah North - AAA 1					NB28	Sector Tonopah North
Tonopah North - Infantry 1				NB28	Sector Tonopah North

////PAHUTE

Pahute - Relay Tower					NB42	Sector Pahute
Pahute - Tech Warehouse					NB42	Sector Pahute
Pahute - SAM 1 (SA-9)					NB41	Sector Pahute
Pahute - AAA 1							NB42	Sector Pahute
Pahute - Artillery 1					NB41	Sector Pahute

////62A

62A - Trucks 1							PA37
62A - Buses 1							PA37
62A - Garage							PA37
62A - Vaz 1								PA37

////TONOPAH SOUTH
--Fake Airfield
Tonopah South - Tu-95MS					NB13
Tonopah South - IL-76MD					NB13
Tonopah South - Hangar West				NB13
Tonopah South - Hangar East				NB13
Tonopah South - Comms					NB13
--Factory
Tonopah South - Factory					NB03
Tonopah South - Refinery				NB03
Tonopah South - Chemical Tank			NB03
Tonopah South - Tech Hangar				NB03
Tonopah South - Boiler House			NB03

////TONOPAH EAST
--Dead Horse Flat 
Tonopah East - SAM 1					NB63	
Tonopah East - AAA 1					NB63
Tonopah East - Artillery 1				NB63
Tonopah East - Armor 1	(T-90)			NB63
Tonopah East - Armor 2 (BMP's)			NB63
Tonopah East - Military HQ				NB63
Tonopah East - Military Barracks		NB63
Tonopah East - Comms					NB63

--------
105 Total
--------

Mobile SAM/Mobile Radar List

"Area 51 - SAM 1", "Area 51 - SAM 2", "Caliente Alpha - SAM 1", "Caliente Alpha - SAM 2", "Caliente Charlie - SAM 1", 
"Pahute - SAM 1", "Rachel - SAM 1", "Rachel - SAM 2", "Tonopah North - SAM 1", "Tonopah East - SAM 1"

]]--